<?php
//post data to realtybaron realanswers post api using PHP CURL extension.
//process response from realtybaron api to determine status of form submission
//whether it is success or bad request!

//include wp-config
$root = dirname(dirname(dirname(dirname(__FILE__))));
if (file_exists($root.'/wp-load.php')) {
// WP 2.6
require_once($root.'/wp-load.php');
} else {
// Before 2.6
require_once($root.'/wp-config.php');
}

/*******************The below checks post from form********************/

if(isset($_POST['process'])== 'yes_process'){

//recaptcha codes
require_once(WP_PLUGIN_DIR.'/realanswers/recaptchalib.php');
$real_captcha_private = get_option('real_captcha_private');
$resp = recaptcha_check_answer ($real_captcha_private,
                                $_SERVER["REMOTE_ADDR"],
                                $_POST["recaptcha_challenge_field"],
                                $_POST["recaptcha_response_field"]);
								
//check wp_nonce first!
//nonce pass from webpage
$nonce_value = $_POST['_wpnonce'];
//security check using nonce created by wp_create_nonce('realanswers-nonce');
//so as to determine data come from webpage
if (!wp_verify_nonce($nonce_value, 'realanswers-nonce') ) die('Failed Security check'); 


//data posted from form assigned to variables to be posted to realtybaron post api
$context = $_POST['location_type'];
$location = $_POST['location_name'];
$subject = $_POST['subject'];
$body = $_POST['question_detail'];
$tag = $_POST['tags'];

//The following split up tags and rejoin as tag=tag1&tag=tag2
$post_tags = null;//empty variable
$split_tags = explode(" ", $tag);//split up space and assign to array $split_tags
foreach ($split_tags as $split_tag){//combine string back as tag=tag1&tag=tag2&
$post_tags .= "tag=".$split_tag."&";
}
//remove the last & from the combined string and assign to $postdata!
$combine_tags = substr($post_tags, 0, -1); 
 
$notify_me = $_POST['notify_me'];
$open_days = 3;
$construct_redo_url = get_bloginfo('url')."/realanswers/redo?question_id={0}";
$redo_url = $construct_redo_url;
$construct_answer_url = get_bloginfo('url')."/realanswers/answers?question_id={0}";
$answer_url = $construct_answer_url;
$api_key = get_option('real_apikey');
$fname = $_POST['fname'];
$lname = $_POST['lname'];
$email = $_POST['email'];
$tou = $_POST['tou'];

//recaptcha check
//if invalid return form as redo with posted contents.
if (!$resp->is_valid) {

	$status_message = "<div class='new_question_error'><ul>"; 
	$status_message .= "<li><span class='label-highlight'>Incorrect CAPTCHA.</span></li>";
	$status_message .= "<li><span class='label-highlight'>Please re-type the two words found in the reCAPTCHA form.</span></li>";
	$status_message .= "</ul></div>";
	 
//url encode data before sending back to form, so as not to cause newline error in header() function.
	 $context_e = urlencode($context);
	 $location_e = urlencode($location);
	 $subject_e = urlencode($subject);
	 $body_e = urlencode($body);
	 $tag_e = urlencode($tag);
	 $notify_me_e = urlencode($notify_me);
	 $fname_e = urlencode($fname);
	 $lname_e = urlencode($lname);
     $email_e = urlencode($email);
	 $message_e = urlencode($status_message);

	 //construction url back to newquestion form
	 $redo_url = get_bloginfo('url')."/realanswers/newquestions";
	 
	 //populate content to send back to form in newquestions.php
	 $content = "status=redo&context=$context_e&location=$location_e&subject=$subject_e&body=$body_e&tag=$tag_e";
	 $content .= "&notify_me=$notify_me_e&fname=$fname_e&lname=$lname_e&email=$email_e&status_message=$message_e";

     //redirect back to form with populated values.
	 header("location:$redo_url/?$content");
     
	 //prevent php from executing further!
     die();
}//end recaptcha check

//construct post data to be posted to realtybaron post api
$postdata = "location=$location&subject=$subject&body=$body&$combine_tags&notify_me=$notify_me&open_days=$open_days&redo_url=$redo_url&answer_url=$answer_url&api_key=$api_key&fname=$fname&lname=$lname&email=$email&tou=$tou";

	 //use php curl extension to post data to realtybaron post api and parse xml response.
	 
	 global $rsapi;
	 
	 $post_response = $rsapi->post($context,$postdata);
	 
	 /****Start error checking*****/
	 
	 //check if empty response from api redirect with service unavailable message
	 if(empty($post_response)){
	 $redo_url = get_bloginfo('url')."/realanswers/newquestions";
	 header("location:$redo_url/?status=redo&status_message=Service Unavailable");
	 }
	 
	 //if not empty response try whether it is xml, if not redirect back with service unavailable message
	 try{
	 $xml = @new SimpleXMLElement($post_response);
	   //check if there is status code, if not it is probably 404 or 503 apache html response
	   if(empty($xml->status['code'])){
	   $redo_url = get_bloginfo('url')."/realanswers/newquestions";
	   header("location:$redo_url/?status=redo&status_message=Service Unavailable");
	   }
     }	 
	 catch(Exception $e)
     {
	  //xml error message of unable to parse string as xml
	  //$message = $e->getMessage();
	  //construction url back to newquestion form redirect back with service unavailable message
	  $redo_url = get_bloginfo('url')."/realanswers/newquestions";
	  header("location:$redo_url/?status=redo&status_message=Service Unavailable");
	 }
	 
     /*********end error checking************/
	 
	 
	 //get status code 400 error 200 ok
	 $status_code = $xml->status['code'];
		 
	 if($status_code == '200'){// status ok show user the answer.php
	
		   foreach($xml->links->link as $link){
		   
		   if($link['rel'] == "answers"){
		   
		   $redirection_link = $link['href'];
		   
		   header("location:$redirection_link");
		   
		   }
	   
	   }//end foreach
	   
     
	 }elseif($status_code == '400'){// status error show error message and set form status to redo
	 
	 $status_message = "<div class='new_question_error'><ul>"; 
	 foreach ($xml->status->messages->message as $mess){ 
		 $status_message .= "<li>".$mess."</li>";
		 }
     $status_message .= "</ul></div>";
	 
	 //url encode data before sending back to form, so as not to cause newline error in header() function.
	 $context_e = urlencode($context);
	 $location_e = urlencode($location);
	 $subject_e = urlencode($subject);
	 $body_e = urlencode($body);
	 $tag_e = urlencode($tag);
	 $notify_me_e = urlencode($notify_me);
	 $fname_e = urlencode($fname);
	 $lname_e = urlencode($lname);
     $email_e = urlencode($email);
	 $message_e = urlencode($status_message);

	 //construction url back to newquestion form
	 $redo_url = get_bloginfo('url')."/realanswers/newquestions";
	 
	 //create form function as example for perimeters to send back.
	 //create_realanswers_question_form('Ask a Question',$context,$location,$subject,$body,$tag,$notify_me,$fname,$lname,$email,$status_message);
	 
	 //create content to send back to form in newquestions.php
	 $content = "status=redo&context=$context_e&location=$location_e&subject=$subject_e&body=$body_e&tag=$tag_e";
	 $content .= "&notify_me=$notify_me_e&fname=$fname_e&lname=$lname_e&email=$email_e&status_message=$message_e";

     header("location:$redo_url/?$content");
	 
	 }//end if($status_code == '200')

}//end if(isset($_POST['process'])== 'yes_process')
?>